// ---------------------------------------------------------------------------
//	PSG Sound Implementation
//	Copyright (C) cisc 1997, 1999.
// ---------------------------------------------------------------------------
//	$Id: psg.h,v 1.1 1999/03/20 10:12:45 cisc Exp $

#ifndef PSG_H
#define PSG_H

#include "types.h"

// ---------------------------------------------------------------------------

#define SSG_TONESHIFT		24
#define SSG_ENVSHIFT		22
#define SSG_NOISESHIFT		14
#define SSG_OSR				 2

class PSG
{
public:
	typedef int32 Sample;
	PSG();
	virtual ~PSG();

	void Reset();
	void EmitWave(Sample* dest, int nsamples);
	void SetReg(uint regnum, uint8 data);
	void SetPSGClock(int clock, int rate);
	uint8 GetReg(uint regnum) { return reg[regnum]; }
	void SetVolume(int vol);

protected:
	uint8 reg[16];
	static uint enveloptable[16][64];
	static uint8 noisetable[0x8000];
	static int EmitTable[32];

	void MakeNoiseTable();
	void MakeEnvelopTable();
	
	const uint* envelop;
	uint olevel[3];
	uint32 scount[3], speriod[3];
	uint32 ecount, eperiod;
	uint32 ncount, nperiod;
	uint32 tperiodbase;
	uint32 eperiodbase;
	uint32 nperiodbase;
	int volume;
};

#endif // PSG_H