// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1997, 1999.
// ---------------------------------------------------------------------------
//	Sound Implemention for Win32
// ---------------------------------------------------------------------------
//	$Id: winsound.h,v 1.2 1999/03/28 06:56:43 cisc Exp $

#if !defined(win32_winsound_h)
#define win32_winsound_h

#include "types.h"
#include "CritSect.h"
#include "pc88/sound.h"
//#include "WinJoy.h"

// ---------------------------------------------------------------------------

class PC88;

namespace PC8801
{

class Config;

class WinSound : public Sound
{
private:
	class Driver
	{
		static const uint num_blocks;
		static const uint timer_resolution;

	public:
		Driver();
		~Driver();

		bool Init(WinSound* ws, HWND hwnd, uint rate, uint ch, uint buflen);
		bool Cleanup();
		void Send();

	private:
		static void CALLBACK TimeProc(UINT, UINT, DWORD, DWORD, DWORD);

		LPDIRECTSOUND lpds;
		LPDIRECTSOUNDBUFFER lpdsb_primary;
		LPDIRECTSOUNDBUFFER lpdsb;
		UINT timerid;
		LONG sending;
		
		WinSound* winsound;
		uint nextwrite;
		uint buffersize;
		uint buffer_length;
		bool playing;
	};
	friend class Driver;

public:
	WinSound(const ID& id, const ID& idopn1, const ID& idopn2);
	~WinSound();

	bool Init(PC88* pc, HWND hwnd, uint rate, uint32 clock, uint buflen);
	bool ChangeRate(uint rate, uint32 clock, uint buflen);
	
	void ApplyConfig(const Config* config);
	void SetVolume(const Config* config);

	const uint8* FillBlock(uint);


private:
	bool InitSoundBuffer(LPDIRECTSOUND lpds, uint rate);
	void Cleanup();
	void Store(int count);
	
	Driver driver;
	
	HWND hwnd;
	CriticalSection csmix;
	uint currentrate;
	uint currentbuflen;

	bool enablesound;
	bool enablepad;
};

}

#endif // !defined(win32_winsound_h)
